#import <Cocoa/Cocoa.h>
#import "EAGLView_mac.h"

#define HVGA 1
#define DVGA 2
#define QHD 3
#define WXGA 4
#define WVGA 5
#define FWVGA 6
#define XGA 7
#define WSVGA 8
#define WDVGA 9

#define kPortrait 0
#define kPortraitUpsideDown 1
#define kLandscapeLeft 2
#define kLandscapeRight 3

@interface CustomWindow : NSWindow {
    NSView *background;
    EAGLView	*glView;

    NSPoint initialLocation;
    NSImageView *image;
    
    NSString *imageName;
    int offsetW, offsetH;
    int screenW, screenH;
    int w, h;
    
    int boffsetW, boffsetH;
    int bscreenW, bscreenH;
    int bw, bh;
    
    float scale;
}

@property (assign) NSPoint initialLocation;
@property (nonatomic) int offsetW, offsetH, screenW, screenH, w, h;
@property (nonatomic) int boffsetW, boffsetH, bscreenW, bscreenH, bw, bh;
@property (nonatomic) float scale;
@property (nonatomic, retain) EAGLView	*glView;

- (id)initWithResolution: (int) resolution;
- (void) scale:(int)orientation;
- (void) setScreenScale:(float) newScale;
- (void)redrawWindow:(int)orientation;
- (void)redrawWindow:(int)orientation withScale:(float) scale;

@end
